# 'compute' is distributed to each node running 'dispynode'
def compute(n):
    import time, socket
    time.sleep(n)
    host = socket.gethostname()
    return (host, n)

if __name__ == '__main__':
    import dispy, dispy.httpd, random, os, sys, threading, time
    if sys.version_info.major > 2:
        from http.server import HTTPServer
    else:
        from BaseHTTPServer import HTTPServer

    dispy.httpd.cluster_poll_sec = 4
    httpd = HTTPServer(('', 8080), dispy.httpd.GetHandler)
    threading.Thread(target=httpd.serve_forever).start()
    print('Started httpd server at %s:%s\n' % httpd.socket.getsockname())

    cluster = dispy.JobCluster(compute, node_status=dispy.httpd.node_status)
    jobs = []
    for i in range(10):
        # schedule execution of 'compute'
        job = cluster.submit(random.randint(5,20))
        job.id = i # optionally associate an ID to job (if needed later)
        jobs.append(job)
        dispy.httpd.jobs_submitted += 1
    cluster.wait() # wait for all scheduled jobs to finish

    cluster.stats()
    # wait until httpd client gets all info about nodes/jobs
    time.sleep(dispy.httpd.cluster_poll_sec)
    cluster.close()
    httpd.shutdown()

